--CREATE INDEX connections_jsonindex ON de_chstations USING GIN (connections_js);

CREATE OR REPLACE FUNCTION analyseChJSON(chStation INTEGER)
RETURNS TABLE(LevelID int, PowerKW numeric, Quantity int, ConnectionTypeID int,
              Amps int, Voltage int)
AS
$BODY$
  SELECT "LevelID", "PowerKW", "Quantity", "ConnectionTypeID", "Amps", "Voltage" 
  FROM de_chstations CROSS JOIN lateral jsonb_to_recordset(connections_js) 
     AS x("LevelID" int, "PowerKW" numeric, "Quantity" int, "ConnectionTypeID" int, 
	  "Amps" int, "Voltage" int)   
  WHERE id = chStation
  ORDER BY "PowerKW" DESC;
$BODY$
LANGUAGE sql;
