CREATE OR REPLACE FUNCTION chargingTime(chStation INTEGER, currentSoC NUMERIC, batteryKW NUMERIC, requiredSoC NUMERIC, carLimit NUMERIC, currentTime TIMESTAMP)
RETURNS INTEGER[]

AS
$BODY$
DECLARE
  allRes REFCURSOR;
  oneRes RECORD;
  iterator INTEGER := 1;
  chEfficiency NUMERIC[];
  maxSoC NUMERIC := 1;
  powerKW NUMERIC := 0;
  finalState NUMERIC[] := ARRAY[0,0];
  i INTEGER;
  totalTime NUMERIC :=0;
  minusTime NUMERIC := 0;
  cSoC NUMERIC := currentSoC/100;
BEGIN
  chEfficiency := ARRAY [[0,0,0],[0.5,0.95,0],[0.6,0.85,0],[0.7,0.75,0],[0.8,0.65,0],[1,0.50,0]];

  OPEN allRes FOR
  SELECT *
  FROM analyseChJSON(chStation)
  ORDER BY PowerKW DESC;

  LOOP
   FETCH allRes INTO oneRes;
   EXIT WHEN NOT FOUND;
   IF (iterator = 1) THEN
     powerkw := oneRes.powerkw;
     IF (oneRes.powerkw > 40) THEN
       maxSoC := 0.8;
     END IF;
     EXIT;
   END IF;
  END LOOP;

  RAISE NOTICE 'max power: %', powerKW;
  
  IF (powerKW IS NOT NULL) THEN 
    --chEfficiency[1][3] := batteryKW*chEfficiency[1][1]/(powerKW*chEfficiency[1][2]);
    FOR i IN 2..array_length(chEfficiency, 1) LOOP
      --RAISE NOTICE 'intermediate state of charge : %', chEfficiency[i][1];
      chEfficiency[i][3] := (batteryKW*(chEfficiency[i][1]-chEfficiency[i-1][1]))/(powerKW*chEfficiency[i][2]);
      IF (cSoC>chEfficiency[i-1][1] AND cSoC<=chEfficiency[i][1]) THEN
        minusTime := chEfficiency[i][3] * (cSoC - chEfficiency[i-1][1])/((chEfficiency[i][1]-chEfficiency[i-1][1]))+TotalTime;
	
      END IF;
      --RAISE NOTICE 'calculated time: %', chEfficiency[i][3];
     TotalTime := TotalTime +  chEfficiency[i][3];
     EXIT WHEN chEfficiency[i][1] = maxSoC; 
    END LOOP;
   --RAISE NOTICE 'Minus time: %', minusTime;
   finalState[1] := maxSoC*100;
   finalState[2] := ROUND((TotalTime-minusTime)*60);
  END IF;

 RETURN finalState;
 
END
$BODY$
LANGUAGE plpgsql;

