DROP TABLE Plans;
CREATE TABLE Plans(
 id integer PRIMARY KEY,
 measure char(2),
 units INTEGER,
 check (measure in ('ho','qu', 'hf') AND ((measure ='ho' AND units = 60) OR (measure ='qu' AND units = 15) OR (measure ='hf' AND units = 30))) --measure hours, quarters, half an hour
);

INSERT INTO Plans VALUES 
(1, 'ho', 60), --just travelling
(2, 'ho', 60), --business premises
(3, 'ho', 60) --for testing purposes!!!
;

--general availability schema for intervals of the day and based on the weekday
DROP TABLE ChargerAvailabilityPlan;
CREATE TABLE ChargerAvailabilityPlan(
  planID integer references Plans(id),
  startTime TIME,
  endTime TIME,
  weekday integer,
  coef numeric
);

INSERT INTO ChargerAvailabilityPlan VALUES
(1, '06:00', '07:00', 1, 0.1),
(1, '07:00', '08:00', 1, 0.2),
(1, '08:00', '09:00', 1, 0.1),
(1, '11:00', '12:00', 1, 0.1),
(1, '12:00', '13:00', 1, 0.2),
(1, '16:00', '17:00', 1, 0.1),
(1, '17:00', '18:00', 1, 0.2),
(1, '18:00', '19:00', 1, 0.3),
(1, '19:00', '20:00', 1, 0.1);

INSERT INTO ChargerAvailabilityPlan VALUES
(2, '00:00', '01:00', 1, -1),
(2, '01:00', '02:00', 1, -1),
(2, '02:00', '03:00', 1, -1),
(2, '03:00', '04:00', 1, -0.5),

(2, '06:00', '07:00', 1, 0.2),
(2, '07:00', '08:00', 1, 0.5),
(2, '08:00', '09:00', 1, 0.5),
(2, '09:00', '10:00', 1, 0.3),
(2, '10:00', '11:00', 1, 0.3),
(2, '11:00', '12:00', 1, 0.2),
(2, '12:00', '13:00', 1, 0.2),
(2, '13:00', '14:00', 1, 0.1),
(2, '14:00', '15:00', 1, 0.1),
(2, '15:00', '16:00', 1, 0.1),
(2, '16:00', '17:00', 1, 0.1),
(2, '17:00', '18:00', 1, 0.1),
(2, '18:00', '19:00', 1, 0.1),
(2, '19:00', '20:00', 1, 0.1),

(2, '22:00', '23:00', 1, -0.5),
(2, '23:00', '24:00', 1, -1)
;

INSERT INTO ChargerAvailabilityPlan VALUES
(3, '00:00', '01:00', 1, -0.6),
(3, '01:00', '02:00', 1, 0.3),
(3, '02:00', '03:00', 1, -0.5);

CREATE INDEX chAvailability_ind ON ChargerAvailabilityPlan (planID, StartTime, weekday);





