CREATE OR REPLACE FUNCTION generateOneChargerProfile(chStation INTEGER)
RETURNS INTEGER[]

AS
$BODY$
DECLARE
  wTime NUMERIC[];
  allRes REFCURSOR;
  oneRes RECORD;
  iterator INTEGER := 1;
  no_fast INTEGER := 0;
  no_slow INTEGER := 0;
  wType VARCHAR := 'slow';
  w1 INTEGER;
  w2 INTEGER;
  maxspeed INTEGER;
  delta0 INTEGER;
  DELTA INTEGER;
BEGIN

  OPEN allRes FOR
  SELECT *
  FROM analyseChJSON(chStation)
  ORDER BY PowerKW DESC;

  LOOP
   FETCH allRes INTO oneRes;
   EXIT WHEN NOT FOUND;
   IF (iterator = 1) THEN
     IF (oneRes.powerkw >= 150)
         THEN wType = 'rapid';
     ELSIF (oneRes.powerkw < 150 AND oneRes.powerkw >= 50)
         THEN wType = 'fast50';
     ELSIF (oneRes.powerkw < 50 AND oneRes.powerkw > 40)
         THEN wType = 'fast43';
     ELSIF (oneRes.powerkw <= 40 AND oneRes.powerkw >= 22)
         THEN wType = 'slow22';	 
     END IF;
     
     SELECT timeFrom, timeTo
     INTO w1, w2
     FROM WaitingTypes
     WHERE wType = ID;
	 
     --RAISE NOTICE 'PowerKW %', oneRes.powerkw;
   END IF;
   
   IF (oneRes.powerkw > 40) THEN no_fast := no_fast + oneRes.quantity;
   ELSE no_slow := no_slow + oneRes.quantity;
   END IF;
   
   iterator := iterator + 1;
  END LOOP;
  CLOSE allRes;


  OPEN allRes FOR
  SELECT kmh, sum(km), fulllength, sum(km)/fulllength
  FROM grm_2po_4pgr, (
    SELECT ST_Buffer(geom,0.0018) buf
    FROM de_chstations d
    WHERE d.id=148031
    ) AS st,
    (SELECT sum(km) fulllength
     FROM grm_2po_4pgr, (
      SELECT ST_Buffer(geom,0.0018) buf
      FROM de_chstations d
      WHERE d.id= chStation
      ) as st
      WHERE ST_Intersects(geom_way,buf)) AS total
    WHERE ST_Intersects(geom_way,buf) 
  GROUP BY kmh,fulllength
  ORDER BY kmh DESC;

  iterator := 1;
  LOOP
   FETCH allRes INTO oneRes;
   EXIT WHEN NOT FOUND;
   IF (iterator = 1) THEN
     maxspeed := oneRes.kmh;
   END IF;
   iterator := iterator + 1;
   --RAISE NOTICE 'kmh %', oneRes.kmh;
  END LOOP;
  CLOSE allRes;

  
  IF (no_fast > 0) THEN 
    BEGIN
      DELTA := w2/no_fast;
      IF (no_fast <= 4) THEN
        BEGIN
          w1 := w2/2;
	  w2 := w2+DELTA;
        END;
      ELSIF (no_fast > 4 AND no_fast < 10) THEN
        BEGIN
	 w1 := w1+DELTA;
         w2 := w2/2+DELTA;
	END;
      ELSE w2 := DELTA;
      END IF;
      IF (maxspeed >= 100) THEN
        BEGIN
	  delta := (w2-w1)/2;
	  w1 := w1+ delta;
	  w2 := w2+ delta;
	END;
      END IF;	
    END;
  ELSIF (no_slow > 0) THEN
    BEGIN
       IF (maxspeed < 40 AND no_slow < 4) THEN
        BEGIN
	  delta0 := w2/no_slow;--(w2 - w1) * 0.1;
	  w1 := delta0;--w2 - delta;
	  w2 := w2+delta0;--w2 + (w2-w1)/2;
	END;
       END IF;		
    END;
  END IF;

  --RAISE NOTICE 'fast %', no_fast;

  wTime[1] := w1;
  wTime[2] := w2;

  RETURN wTime;
END
$BODY$
LANGUAGE plpgsql;

