//
// Created by linb on 2020-11-12.
//

#ifndef CAT_PROFILES_KATCH_H
#define CAT_PROFILES_KATCH_H


#include <iostream>
#include <stdlib.h>
#include <string>

#include "util/misc.h"
#include "io/btch_format.h"
#include "io/demands_format.h"
#include "io/edge_info.h"
#include "query/tch_ea_query.h"

using Graph = katch::TchEaQuery::Graph;
using EdgeInfo = katch::EdgeInfo<Graph::TTF>;
using std::string;

namespace CATs {
    class KaTCH {
    private:
        std::unique_ptr<katch::TchEaQuery> query_graph; ///Loaded Graph structure for any query
        bool isLoaded = 0;
    public:
        int load (const string &);
        int query ( katch::TchEaQuery::Path &, const uint32_t , const uint32_t, const double, const double, const uint32_t);
    }; //class
}; //namespace

#endif //CAT_PROFILES_KATCH_H
