//
// Created by agne on 2020-11-09.
//

#include "reading.h"
//granularity in seconds
//1 day=24x60x60=86400
//const std::string CATs::reading::waitingTimesFile = settings::waitingTimesFile;

bool CATs::reading::loadStWT(allWT &allSTs) {
    //int granularity = settings::granularity;
    fstream fin;
    string line;
    fin.open(sett.waitingTimesFile, ios::in);
    if (fin.is_open()){
        while ( getline (fin,line) ){
            std::vector<std::string> words;
            split1(line, words);
            int size = words.size();
            if ((size - 1)/2 != 86400/settings::Settings::granularity) {
                cout << "wrong structure of the file for waiting times at charging stations";
                fin.close();
                return false;
            }
            else{
                CStID stid = std::stoi(words[0]);
                WT oneST = WT();
                Time timeValue = 0;
                for (int i = 1; i < size; i+=2) {
                    Interval<Time> timeInterval;
                    timeInterval.b = std::stoi(words[i]) * 60 * 10; //*10 to manipulate in deciseconds
                    timeInterval.e = std::stoi(words[i + 1]) * 60 * 10;
                    oneST.insert({timeValue, timeInterval});
                    timeValue = timeValue + settings::Settings::granularity;
                }
                allSTs.insert({stid, oneST});
            }
        }
        cout <<"Charging station waiting times loaded successfully. Number of CHSt:" <<allSTs.size() << "\n";
        fin.close();
    }
    else {cout << "Unable to open file of waiting times"; return false;}
    return true;
}

bool CATs::reading::loadStCHF(allCHF &chfunctions){
    fstream fin;
    string line;
    fin.open(sett.chargingFunctions, ios::in);
    if (fin.is_open()){
        while ( getline (fin,line) )
        {
            std::vector<std::string> words;
            split1(line, words);
            int size = words.size();
            CHF oneCH = CHF();
            CATs::CStID stid = std::stoi(words[0]);
            if (size > 1){
                chfp chargingPoint;
                for (int i = 1; i < size; i+=2) {
                    chargingPoint.ch = std::stoi(words[i]);
                    chargingPoint.t = std::stoi(words[i + 1]) * 60 * 10; //*10 to manipulate in deciseconds
                    oneCH.push_back(chargingPoint);
                }
                chfunctions.insert({stid, oneCH});
            }
        }
        cout <<"Charging functions loaded successfully. No of CHSts: "<< chfunctions.size()<<"\n";
        fin.close();
    }
    else {cout << "Unable to open file of charging functions"; return false;}
    return true;
}

bool CATs::reading::loadStationMapKatch(MapKatch &stM) {
    fstream fin;
    string line;
    fin.open(sett.mappingStationsToKatch, ios::in);
    if (fin.is_open()){
        while ( getline (fin,line) ){
            std::vector<std::string> words;
            split1(line, words);
            if (words.size() != 2) return false;

            CATs::CStID stid = std::stoi(words[0]);
            CATs::NodeID node = std::stoi(words[1]);
            stM.insert({stid, node});
        }
        cout <<"Mapping of stations to KATCH nodes loaded successfully. No of CHSts: "<< stM.size()<<"\n";
        fin.close();
    }
    else {cout << "Unable to open file of mapping stations to KATCH nodes"; return false;}
    return true;
}
