//
// Created by agne on 2021-01-05.
//

#include "settings.h"

using namespace settings;

void Settings::loadDefaults()
{
    Settings::delta       = 15*600; // Length of a time slot: 15 minutes
    Settings::granularity = 3600;
    Settings::results     = 5;     // number of results computed for each routing query
    Settings::battery     = 75;    // battery size in kWh
    Settings::bufferCSt   = 5000;  // buffer size around route in meters to look for stations
    Settings::kCSt        = 10;    // # of Ch. Station candidates considered on each leg
    Settings::alpha       = 0.1;   // Alg. parameter in [0..1]. Small alpha = few ch. stops
}


void Settings::loadFromINI(const std::string& ininame) {
    mINI::INIFile fileToLoad(ininame);
    fileToLoad.read(globalINI);
    hostDB = globalINI.get("pgSQL").get("host");
    portDB = globalINI.get("pgSQL").get("port");
    nameDB = globalINI.get("pgSQL").get("database");
    userDB = globalINI.get("pgSQL").get("user");
    passwdDB = globalINI.get("pgSQL").get("password");
    granularity = atoi(globalINI.get("general").get("granularity").c_str());
    waitingTimesFile = globalINI.get("PreloadedData").get("waitingTimes");
    chargingFunctions =globalINI.get("PreloadedData").get("chargingFunctions") ;
    mappingStationsToKatch = globalINI.get("PreloadedData").get("mappingStationsToKatch");
    btchfile = globalINI.get("KaTCH").get("btchfile");
}


//mINI::INIStructure settings::Settings::globalINI("default.ini");

std::string Settings::mappingStationsToKatch  = "stationsMapKatch.csv";
std::string Settings::waitingTimesFile = "waitingTimesByHour.csv"; //Testing with file: waitingTimesTest.csv
std::string Settings::chargingFunctions = "chargingTimesBySoC_battery62.csv"; //Testing with file chargingFunctionsTest.csv
std::string Settings::userDB = "";
std::string Settings::passwdDB = "";
std::string Settings::nameDB = "";
std::string Settings::hostDB = "";
std::string Settings::portDB = "";
std::string Settings::btchfile = "";



