//
// Created by linb on 2020-11-11.
//

#ifndef CAT_PROFILES_SIGHANDLERS_H
#define CAT_PROFILES_SIGHANDLERS_H

#include <stdio.h>
#include <execinfo.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

//! Signal handler for printing stacktrace for debug purposes.
//! \param sig   signal to cache
void handlerForStackTrace(int sig) {
  void *array[10];
  size_t size;

  /// get void*'s for all entries on the stack
  size = backtrace(array, 10);
    if (size == 0) {
        fprintf(stderr, "  <empty, possibly corrupt>\n");
        exit(1);
    }
  /// print out all the frames to stderr
  fprintf(stderr, "Error: signal %d:\n", sig);
  backtrace_symbols_fd(array, size, STDERR_FILENO);
  exit(1);
}



#endif //CAT_PROFILES_SIGHANDLERS_H
