//
// Created by agne on 2020-11-09.
//

#ifndef DB_HANDLER_STRINGTOOLS_H
#define DB_HANDLER_STRINGTOOLS_H

#include <string>
#include <sstream>
#include <algorithm>
#include <iterator>
#include <iostream>

using namespace std;

template <class Container>
void split1(const std::string &str, Container &cont) {
    std::istringstream iss(str);
    std::copy(std::istream_iterator<std::string>(iss),
              std::istream_iterator<std::string>(),
              std::back_inserter(cont));
}

template <class Container>
void stringVec2stringJSON(const Container &cont, std::string &str) {
    str.append("\'{");
    for(const auto& n: cont) {
        str.append("\"");
        str.append(n);
        str.append("\",");
    }
    str.erase(std::prev(str.end()));
    str.append("}\'::text[]");
}
template <class Container>
void stringVec2string(const Container &cont, std::string &str) {
    str.append("{");
    for(const auto& n: cont) {
        str.append("\"");
        str.append(n);
        str.append("\",");
    }
    str.erase(std::prev(str.end()));
    str.append("}");
}


#endif //DB_HANDLER_STRINGTOOLS_H
