//
// Created by linb on 2021-01-07.
//

#include "triprouter.h"

int CATs::TripRouter::KaTCHinit()
{
    katch = std::make_unique<KaTCH>();
    return katch->load(defSets.btchfile);
}

int CATs::TripRouter::SUMOcallibration(const int filter) {

    double   departure_time=0; //288000;  00:00.0
    double   arrival_time =863099; //288100;  23:59:9
    uint32_t rank= 4;
    katch::TchEaQuery::Path resultPath(1, arrival_time);
    std::vector<string> kresult;
    katch::NodeIterator u, v;

    std::vector<Trip> trips = db->getTrips_calibrate_log();
    cout<<"Number of Trips in DB to calibrate: "<<trips.size()<<endl;
    for (auto a: trips) {

        cout<<"TripRouter: El id: "<< a.id << endl;
        katch->query(resultPath, a.source, a.dest, departure_time, arrival_time, rank);
        for( size_t  i = 0 ; i < resultPath.get_n_edges(); i++ ){
            u = std::get<0>(resultPath.get_edge(i));
            //e = std::get<1>(resultPath.get_edge(i));
            v = std::get<2>(resultPath.get_edge(i));
            std::string onepoint="";
            onepoint.append(to_string(u) );
            onepoint.append("-");
            onepoint.append(to_string(v));
            //cout<<onepoint<<"|";
            kresult.push_back(onepoint);
            //KATCH_CONTINUE_STATUS("\"" << u <<"-" << v << "\",");
            onepoint.clear();
        }
        if(kresult.size() != 0) db->insertTrip_KATCH_calibrate_log(a.id , kresult);
        else cout<<"kresultset = 0"<<endl;
        kresult.clear();
        resultPath.clear(); ///clean the Path just in case
    }

  //  db->insertTrip_KATCH_calibrate_log(3, pairs3);

    return EXIT_SUCCESS;
}

int CATs::TripRouter::TestKaTCHSmall(const int filter=0) {
      uint32_t dest = 6;
      double   departure_time= 288000;
      double   arrival_time = 288100;
      uint32_t rank= 4;
      katch::TchEaQuery::Path resultPath(dest, arrival_time);
      katch->query(resultPath, 1, dest, departure_time, arrival_time, rank);

    return 0;
}
