ALTER TABLE de_chstations 
   ADD COLUMN snap_node_id integer,
   ADD COLUMN snap_node_dist float;

CREATE TEMP TABLE snappings (chid integer, node_id integer, dist float);

INSERT into snappings (chid, node_id, dist) 
SELECT
  ch.id as chid,
  closest_node.id as node_id,
  closest_node.dist as dist
 FROM de_chstations as ch
LEFT JOIN LATERAL 
  (SELECT
      id, 
      ST_Distance(geom_vertex::GEOGRAPHY, geom::GEOGRAPHY) as dist
      FROM grm_2po_vertex    
      ORDER BY geom_vertex <-> geom
      LIMIT 1
   ) AS closest_node
   ON TRUE;

UPDATE de_chstations 
 SET snap_node_id = snappings.node_id,
     snap_node_dist = snappings.dist
FROM snappings
WHERE de_chstations.id = snappings.chid;
