
create temp table chstat_import ( j jsonb );
\copy chstat_import from '.\de_chstat_flat.json';

 DROP TABLE public.de_chstations;

CREATE TABLE public.de_chstations
(
  id integer,
  is_recently_verified boolean,
  date_last_verified date,
  uuid text,
  data_provider_id integer,
  operator_id integer,
  usagetype_id integer,
  addr_id integer,
  geom geometry(Point,4326),
  connections_js jsonb,
  connections_power_kw_total real,
  number_of_points integer,
  status_type_id integer,
  date_last_status_update date,
  data_quality_level integer,
  date_created date,
  submission_status_type_id integer,
  CONSTRAINT de_chstations_pkey PRIMARY KEY (id)		
)
TABLESPACE pg_default;


insert into public.de_chstations (
  id,
  is_recently_verified,
  date_last_verified,
  uuid,
  data_provider_id,
  operator_id,
  usagetype_id,
  addr_id,
  geom,
  connections_js,
  connections_power_kw_total,
  number_of_points,
  status_type_id,
  date_last_status_update,
  data_quality_level,
  date_created,
  submission_status_type_id)
select 
  (j->>'ID')::int,
  (j->>'IsRecentlyVerified')::boolean,
  (j->>'DateLastVerified')::date,
  j->>'UUID',
  (j->>'DataProviderID')::int,
  (j->>'OperatorID')::int,
  (j->>'UsageTypeID')::int,
  (j->>'AddrID')::int,
  ST_GeomFromText(CONCAT('POINT(', j->>'AddrLongitude',' ',j->>'AddrLatitude',')'), 4326), 
  j->'Connections',  
  (j->>'ConnectionsPowerKWTotal')::real,
  (j->>'NumberOfPoints')::int,
  (j->>'StatusTypeID')::int,
  (j->>'DateLastStatusUpdate')::date,
  (j->>'DataQualityLevel')::int,
  (j->>'DateCreated')::date,
  (j->>'SubmissionStatusTypeID')::int
from chstat_import;
	  	  

DROP INDEX public.sidx_de_chstations_geom;

CREATE INDEX sidx_de_chstations_geom
    ON public.de_chstations USING gist
    (geom)
    TABLESPACE pg_default;

CREATE OR REPLACE INDEX sidx_de_station_snapnode_id
    ON de_chstations USING hash
    (snap_node_id)
    TABLESPACE pg_default;	
	
drop table chstat_import;