import psycopg2
import matplotlib.pyplot as plt

def get_elevations(conn, geojson, precision):   
    elevations = []
    cur = conn.cursor()

    cur.execute("select elev from dl_elevations(" + geojson + "," + str(precision) + ")")

    rows = cur.fetchall()
    print("The number of parts: ", cur.rowcount)
    for row in rows:
        elevations.append(row[0])
    cur.close()
    return elevations

def get_climb(conn, geojson, precision):
    cur = conn.cursor()

    cur.execute("select * from dl_lineclimb(" + geojson + "," + str(precision) + ")")

    row = cur.fetchone()
    cur.close()
    return row

conn = None
try:
 
    conn = psycopg2.connect(host="localhost",port="5430", database="postgis_30_sample", user="postgres", password="daltra4daltra")

    geojson = """
    '{"type": "LineString","coordinates": [[7.65129,47.88411],[7.841491,47.88181]]}'
    """
    precision = 40

    elevations = get_elevations(conn, geojson, precision)
    lineclimb = get_climb(conn, geojson, precision)
    print(lineclimb)

    plt.plot(elevations)
    plt.suptitle("Precision:"+str(precision)+" points:"+str(len(elevations)))
    plt.title("climb:"+str(lineclimb[0])+" climb_dist:"+str(
        lineclimb[1])+" roll:"+str(lineclimb[2])+" roll_dist:"+str(lineclimb[3]))
    plt.show()


except (Exception, psycopg2.DatabaseError) as error:
    print(error)
finally:
    if conn is not None:
        conn.close()
        print('Database connection closed.')
 
