-- https://gis.stackexchange.com/questions/334020/using-st-segmentize-to-postgresql-table-of-segments
--SELECT pointid, ST_Value(rast, ST_SetSRID(ST_MakePoint(x, y1), 12345)) val FROM rastertable, pointtable WHERE ST_Intersects(rast, ST_SetSRID(ST_MakePoint(x, y), 12345))
WITH
  densified AS (
    SELECT ST_Segmentize(geom::GEOGRAPHY, 90) as geom -- every 50m
	       FROM public.pagrindiniai_keliai pk
           where pk.id = 340400
  )
select 
   ROW_NUMBER() OVER() AS id, dmp.path, dmp.geom,
   ST_Value(dem.rast, dmp.geom) AS ele 
from 
   densified as l,	  
   LATERAL ST_DumpPoints(l.geom::GEOMETRY) AS dmp,	  
   public.de_srtm dem
where
 ST_Intersects(dmp.geom, dem.rast)
order by id asc
	