-- clazz, tag, speed ms
--   63 living_street; 2.78
--   11 motorway; 39.44
--   12 motorway_link; 22.22
--   15 primary; 27.78
--   16 primary_link; 22.22
--   41 residential; 13.89
--   21 secondary; 27.78
--   22 secondary_link; 22.22
--   51 service; 5.56
--   31 tertiary; 22.22
--   32 tertiary_link; 22.22
--   13 trunk; 27.78
--   14 trunk_link; 22.22
--   43 unclassified; 13.89
--   42 road
-- unsurfaced; 8.33
-- highspeed; 69.44
-- preserved; 27.78


create temp table sumo_default_speed(clazz integer, speed float);
insert into sumo_default_speed VALUES 
  (63, 2.78), 
  (11, 39.44),
  (12, 22.22),
  (15, 27.78),
  (16, 22.22),
  (41, 13.89),
  (21, 27.78),
  (22, 22.22),
  (51, 5.56),
  (31, 22.22),
  (32, 22.22),
  (13, 27.78),
  (14, 22.22),
  (43, 13.89),
  (42, 13.89);
  
CREATE  INDEX idx_clazz ON sumo_default_speed (clazz);


ALTER TABLE grm_2po_4pgr 
   ADD COLUMN t_ms float,
   ADD COLUMN t_reverse_ms float,
   ADD COLUMN t_time float,
   ADD COLUMN t_reverse_time float;

CREATE  INDEX idx_grm_2po_4pgr_clazz ON grm_2po_4pgr (clazz);

with sumo as ( select clazz as clazz_id, speed as spd from sumo_default_speed )
UPDATE grm_2po_4pgr as g 
   SET t_ms = spd,
       t_reverse_ms = spd, 
       t_time  = (km * 1000) / sumo.spd,
       t_reverse_time = (km * 1000)/  sumo.spd
FROM 
   sumo
WHERE  
   g.clazz = sumo.clazz_id;
