create temp table sumo_trfk(osm_id text, max_speed float, reverse_max_speed float);
\copy sumo_trfk from '.\csv\edge_data.csv'  DELIMITER ';' csv header ;

UPDATE sumo_trfk SET  osm_id=  split_part(split_part(osm_id,'#', 1),'_',1);
UPDATE sumo_trfk SET  osm_id=  replace(osm_id,'-', '');

ALTER TABLE sumo_trfk
   ADD COLUMN osm_id_bi bigint;

UPDATE sumo_trfk SET  osm_id_bi =  osm_id::bigint;
 
ALTER TABLE grm_2po_4pgr 
   ADD COLUMN ms float,
   ADD COLUMN reverse_ms float,
   ADD COLUMN time float,
   ADD COLUMN reverse_time float;

with sumo as (
 select osm_id_bi, avg(max_speed) fw, avg(reverse_max_speed) bw from sumo_trfk group by osm_id_bi )
UPDATE grm_2po_4pgr as g 
   SET trfk_ms = fw,
       reverse_trfk_ms = bw, 
       trfk_time  = (km * 1000) / NULLIF(sumo.fw, 0),
       reverse_trfk_time = (km * 1000)/  NULLIF(sumo.bw, 0)
FROM 
   sumo
WHERE  
   g.osm_id = sumo.osm_id_bi;
