create temp table sumo_mapnet(osm_id text, traffic_speed float, reverse_traffic_speed float );
\copy sumo_mapnet from '.\csv\map.csv'  DELIMITER ';' csv header ;

UPDATE sumo_mapnet SET  osm_id=  split_part(split_part(osm_id,'#', 1),'_',1);
UPDATE sumo_mapnet SET  osm_id=  replace(osm_id,'-', '');

ALTER TABLE sumo_mapnet
   ADD COLUMN osm_id_bi bigint;

UPDATE sumo_mapnet SET  osm_id_bi =  osm_id::bigint;
 
ALTER TABLE grm_2po_4pgr 
   ADD COLUMN trfk_ms float,
   ADD COLUMN reverse_trfk_ms float,
   ADD COLUMN trfk_time float,
   ADD COLUMN reverse_trfk_time float;

with sumo as (
 select osm_id_bi, avg(traffic_speed) fw, avg(reverse_traffic_speed) bw from sumo_mapnet group by osm_id_bi
)
UPDATE grm_2po_4pgr as g 
   SET ms = fw,
       reverse_ms = bw, 
       time  = (km * 1000) / NULLIF(sumo.fw, 0),
       reverse_time = (km * 1000)/  NULLIF(sumo.bw, 0)
FROM 
   sumo
WHERE  
   g.osm_id = sumo.osm_id_bi;
