
ALTER TABLE grm_2po_4pgr 
   ADD COLUMN source_h float,
   ADD COLUMN target_h float;
  
UPDATE grm_2po_4pgr as g 
   SET source_h = r.source_h,  
       target_h = r.target_h
FROM 
 (  SELECT 
    net.id as id,
    ST_Value(dem.rast, ST_StartPoint(ST_LineMerge(geom_way))) AS source_h,
	ST_Value(dem.rast, ST_EndPoint(ST_LineMerge(geom_way))) AS target_h	
  FROM 
    grm_2po_4pgr net,
    public.de_srtm dem
  WHERE
    ST_Intersects(net.geom_way, dem.rast)
 ) r
WHERE 
 g.id = r.id;


--UPDATE 5035076
-- Query returned successfully in 5 hr 24 min.

UPDATE grm_2po_4pgr as g 
   SET source_h = r.source_h
FROM 
 (  SELECT 
    net.id as id,
    ST_Value(dem.rast, ST_StartPoint(ST_LineMerge(geom_way))) AS source_h	
  FROM 
    grm_2po_4pgr net,
    public.de_srtm dem
  WHERE
    source_h is null and
    ST_Intersects(ST_StartPoint(ST_LineMerge(geom_way)), dem.rast)
 ) r
WHERE 
 g.id = r.id and g.source_h is null;

--UPDATE 20361
--Query returned successfully in 3 hr 26 min.


UPDATE grm_2po_4pgr as g 
   SET target_h = r.target_h
FROM 
 (  SELECT 
    net.id as id,
    ST_Value(dem.rast, ST_EndPoint(ST_LineMerge(geom_way))) AS target_h	
  FROM 
    grm_2po_4pgr net,
    public.de_srtm dem
  WHERE
    target_h is null and
    ST_Intersects(ST_EndPoint(ST_LineMerge(geom_way)), dem.rast)
 ) r
WHERE 
 g.id = r.id and g.target_h is null;

--UPDATE 22511

--Query returned successfully in 3 hr 46 min.


