#!/bin/bash

BACKCATALOG=log
FDATE=$(date '+%Y-%m-%d_%H:%M:%S')
wget -q -O open_ev_data.csv "https://docs.google.com/spreadsheets/d/1jT9O6YnrRCtY5jjKDL8-3GN5DzCuB64gAi1aL3-I3Ts/export?exportFormat=csv"
REMOTE_EV_FILE=$(md5sum open_ev_data.csv | cut -d ' ' -f 1)
LOCAL_EV_FILE=$(md5sum open_ev_data_full.csv | cut -d ' ' -f 1)
echo "Timestamp to be used: $FDATE"
echo "Remote file hash: $REMOTE_EV_FILE"
echo "Local  file hash: $LOCAL_EV_FILE"

if [ "$REMOTE_EV_FILE" != "$LOCAL_EV_FILE" ] ;  
then
 echo "Differences between downloaded and previous"
 diff open_ev_data_full.csv open_ev_data.csv
 echo "Backing up & Copying"
 cp open_ev_data.csv $BACKCATALOG/$FDATE.csv
 mv open_ev_data.csv open_ev_data_full.csv
fi

cat open_ev_data_full.csv | head -1
wc -l open_ev_data_full.csv
