CREATE TEMP TABLE open_ev_data_temp (
   uuid      VARCHAR(256) not null,
   cbrand    VARCHAR(256) not null,
   ctype     VARCHAR(256),
   cmodel    VARCHAR(256),
   crelease  INTEGER,
   cvariant  VARCHAR(256),
   batusable   VARCHAR(6),
   realconsump VARCHAR(6),
   acphases  INTEGER null,
   maxackw   VARCHAR(6),
   maxdckw   VARCHAR(6),
   type1     VARCHAR(2),
   type2     VARCHAR(2),
   ccs       VARCHAR(2),
   chademo   VARCHAR(2),
   teslasuc  VARCHAR(2),
   teslaccs  VARCHAR(2),
   charg_curve TEXT
);

DROP TABLE open_ev_data;
CREATE TABLE IF NOT EXISTS open_ev_data (
   uuid      VARCHAR(256) not null,
   cbrand    VARCHAR(256) not null,
   ctype     VARCHAR(256),
   cmodel    VARCHAR(256),
   crelease  INTEGER,
   cvariant  VARCHAR(256),
   batusable   NUMERIC(5,2),
   realconsump NUMERIC(5,2),
   acphases  INTEGER,
   maxackw   NUMERIC(5,2),
   maxdckw   NUMERIC(5,2),
   type1     VARCHAR(2),
   type2     VARCHAR(2),
   ccs       VARCHAR(2),
   chademo   VARCHAR(2),
   teslasuc  VARCHAR(2),
   teslaccs  VARCHAR(2),
   charg_curve TEXT,
   PRIMARY KEY (uuid)
);


\COPY open_ev_data_temp FROM '/home/linb/CRON/open_ev_data_full.csv' DELIMITER ',' CSV  HEADER;
select * from open_ev_data_temp LIMIT 2;

INSERT INTO open_ev_data 
  SELECT uuid,cbrand,ctype,cmodel,crelease,cvariant, 
        CAST( COALESCE( NULLIF( regexp_replace(batusable, '[^-0-9.]+', '.', 'g'), ''), '0') AS NUMERIC) batusable,
        CAST( COALESCE( NULLIF( regexp_replace(realconsump, '[^-0-9.]+', '.', 'g'), ''), '0') AS NUMERIC) realconsump,
        acphases,
        CAST( COALESCE( NULLIF( regexp_replace(maxackw, '[^-0-9.]+', '.', 'g'), ''), '0') AS NUMERIC) maxackw,
        CAST( COALESCE( NULLIF( regexp_replace(maxdckw, '[^-0-9.]+', '.', 'g'), ''), '0') AS NUMERIC) maxdckw,
        type1,type2,ccs,chademo,teslasuc,teslaccs, charg_curve
	FROM open_ev_data_temp;

SELECT * from open_ev_data LIMIT 2;

-- \SET ev from '/home/linb/CRON/test2.json'
-- INSERT INTO  open_ev_data VALUES(:'ev');
-- select * from open_ev_data;
